> For the complete documentation index, see [llms.txt](https://waap.docs.link11.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://waap.docs.link11.com/reference-information/api/namespace-reference/users.md).

# Users

## Parameters

The *users* structure contains an integer parameter named **acl**. This represents the user's [Access Level.](/console-walkthrough/system/users-management.md#user-parameters)

When setting this value through the API, the allowable range is from 1 to 20:

* **1-10** is a *WAAP Viewer*.
* **11-20** is a *WAAP Editor*.

Users can also have an acl value in the range **21-100**. This is a *WAAP manager*.

{% hint style="info" %}
The *WAAP manager* access level cannot be assigned to a user through the API. If you need to do this, contact support.
{% endhint %}

## Operations

## GET /api/v4.3/accounts/users

> Get list of users

```json
{"openapi":"3.0.2","info":{"title":"Link11 WAAP","version":"v4.3"},"paths":{"/api/v4.3/accounts/users":{"get":{"operationId":"get_account_users_api_v3_reblaze_tools_account_users__get_389125454321263874","summary":"Get list of users","parameters":[],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/Organization"},"title":"Response Get Account Users Api V4.0 Reblaze Tools Account Users","type":"array"}}},"description":"Users were retrieved successfully"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InputError"}}},"description":"Input Error"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"500":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Internal Server Error"}},"tags":["Users"]}}},"components":{"schemas":{"Organization":{"properties":{"id":{"title":"Id","type":"string"},"name":{"title":"Name","type":"string"},"users":{"items":{"$ref":"#/components/schemas/Account"},"title":"Users","type":"array"}},"required":["name","id","users"],"title":"Organization","type":"object"},"Account":{"properties":{"acl":{"exclusiveMinimum":true,"minimum":0,"maximum":20,"title":"Acl","type":"integer"},"contact_name":{"title":"Contact Name","type":"string"},"email":{"format":"email","title":"Email","type":"string"},"id":{"title":"Id","type":"string"},"mobile":{"title":"Mobile","type":"string"},"org_id":{"title":"Org Id","type":"string"},"org_name":{"title":"Org Name","type":"string"}},"required":["acl","mobile","contact_name","email","org_id","id","org_name"],"title":"Account","type":"object"},"InputError":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"InputError","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"Error":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"Error","type":"object"}}}}
```

## Create new user

> Create new user

```json
{"openapi":"3.0.2","info":{"title":"Link11 WAAP","version":"v4.3"},"paths":{"/api/v4.3/accounts/users":{"post":{"operationId":"create_account_api_v3_reblaze_tools_account_users__post_389125454321263874","description":"Create new user","summary":"Create new user","parameters":[],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AccountCreateInfo"}}},"required":true},"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AccountCreateResp"}}},"description":"New user was created successfully"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InputError"}}},"description":"Input Error"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"500":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Internal Server Error"}},"tags":["Users"]}}},"components":{"schemas":{"AccountCreateInfo":{"properties":{"acl":{"exclusiveMinimum":true,"minimum":0,"maximum":20,"title":"Acl","type":"integer"},"contact_name":{"title":"Contact Name","type":"string"},"email":{"format":"email","title":"Email","type":"string"},"mobile":{"title":"Mobile","type":"string"},"org_id":{"title":"Org Id","type":"string"}},"required":["acl","mobile","contact_name","email","org_id"],"title":"AccountCreateInfo","type":"object"},"AccountCreateResp":{"properties":{"id":{"title":"Id","type":"string"}},"required":["id"],"title":"AccountCreateResp","type":"object"},"InputError":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"InputError","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"Error":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"Error","type":"object"}}}}
```

## GET /api/v4.3/accounts/{entry\_id}

> Get user details

```json
{"openapi":"3.0.2","info":{"title":"Link11 WAAP","version":"v4.3"},"paths":{"/api/v4.3/accounts/{entry_id}":{"get":{"operationId":"get_account_api_v3_reblaze_tools_account_users__account_id___get_208217041468701574","summary":"Get user details","parameters":[{"in":"path","name":"entry_id","description":"Account ID","required":true,"schema":{"title":"Account ID","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AccountFullDetails"}}},"description":"User details were retrieved successfully"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InputError"}}},"description":"Input Error"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"500":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Internal Server Error"}},"tags":["Users"]}}},"components":{"schemas":{"AccountFullDetails":{"properties":{"acl":{"exclusiveMinimum":true,"minimum":0,"maximum":20,"title":"Acl","type":"integer"},"contact_name":{"title":"Contact Name","type":"string"},"email":{"format":"email","title":"Email","type":"string"},"id":{"title":"Id","type":"string"},"mobile":{"title":"Mobile","type":"string"},"org_id":{"title":"Org Id","type":"string"},"org_name":{"title":"Org Name","type":"string"},"otpseed":{"title":"Otpseed","type":"string"}},"required":["acl","mobile","contact_name","email","org_id","id","org_name","otpseed"],"title":"AccountFullDetails","type":"object"},"InputError":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"InputError","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"Error":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"Error","type":"object"}}}}
```

## Modify user

> Update details of a user

```json
{"openapi":"3.0.2","info":{"title":"Link11 WAAP","version":"v4.3"},"paths":{"/api/v4.3/accounts/{entry_id}":{"put":{"operationId":"update_account_api_v3_reblaze_tools_account_users__account_id___put_208217041468701574","summary":"Modify user","description":"Update details of a user","parameters":[{"in":"path","name":"entry_id","description":"Account ID","required":true,"schema":{"title":"Account ID","type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AccountUpdateableInfo"}}},"required":true},"responses":{"200":{"content":{"application/json":{"schema":{}}},"description":"User updated successfully"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InputError"}}},"description":"Input Error"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"500":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Internal Server Error"}},"tags":["Users"]}}},"components":{"schemas":{"AccountUpdateableInfo":{"properties":{"acl":{"exclusiveMinimum":true,"minimum":0,"maximum":20,"title":"Acl","type":"integer"},"contact_name":{"title":"Contact Name","type":"string"},"mobile":{"title":"Mobile","type":"string"}},"required":["acl","mobile","contact_name"],"title":"AccountUpdateableInfo","type":"object"},"InputError":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"InputError","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"Error":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"Error","type":"object"}}}}
```

## Delete user

> Delete user by user id

```json
{"openapi":"3.0.2","info":{"title":"Link11 WAAP","version":"v4.3"},"paths":{"/api/v4.3/accounts/{entry_id}":{"delete":{"operationId":"delete_account_api_v3_reblaze_tools_account_users__account_id___delete_208217041468701574","description":"Delete user by user id","summary":"Delete user","parameters":[{"in":"path","name":"entry_id","description":"Account ID","required":true,"schema":{"title":"Account ID","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{}}},"description":"User was deleted successfully"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InputError"}}},"description":"Input Error"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"500":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Internal Server Error"}},"tags":["Users"]}}},"components":{"schemas":{"InputError":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"InputError","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"Error":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"Error","type":"object"}}}}
```

## GET /api/v4.3/accounts/api-keys

> Get all API keys associated with the planet

```json
{"openapi":"3.0.2","info":{"title":"Link11 WAAP","version":"v4.3"},"paths":{"/api/v4.3/accounts/api-keys":{"get":{"operationId":"get_users_api_keys_api_v3_reblaze_tools_account_api_keys__get_1975536313059833735","parameters":[],"responses":{"200":{"content":{"application/json":{"schema":{"title":"APIKeysGetResponse","properties":{"total":{"type":"integer"},"items":{"type":"array","items":{"$ref":"#/components/schemas/ApiKey"}}}}}},"description":"API keys received successfully"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InputError"}}},"description":"Input Error"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"500":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Internal Server Error"}},"summary":"Get all API keys associated with the planet","tags":["Users"]}}},"components":{"schemas":{"ApiKey":{"properties":{"account_id":{"title":"Account Id","type":"string"},"created_by":{"title":"Created By","type":"string"},"created_time":{"title":"Created Time","type":"number"},"email":{"title":"Email","type":"string"},"id":{"title":"Id","type":"string"},"key":{"title":"Key","type":"string"},"title":{"minLength":1,"title":"Title","type":"string"}},"required":["title","email","account_id","key","id","created_by","created_time"],"title":"ApiKey","type":"object"},"InputError":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"InputError","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"Error":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"Error","type":"object"}}}}
```

## Delete an API key

> Revokes API key and makes it unavailable for use

```json
{"openapi":"3.0.2","info":{"title":"Link11 WAAP","version":"v4.3"},"paths":{"/api/v4.3/accounts/api-keys/{entry_id}":{"put":{"operationId":"revoke_api_key_api_v3_reblaze_tools_account_api_keys__key_id___put_799484225108287879","description":"Revokes API key and makes it unavailable for use","summary":"Delete an API key","parameters":[{"in":"path","name":"entry_id","description":"API key ID","required":true,"schema":{"title":"Key Id","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{}}},"description":"API key was revoked successfully"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InputError"}}},"description":"Input Error"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"500":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Internal Server Error"}},"tags":["Users"]}}},"components":{"schemas":{"InputError":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"InputError","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"Error":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"Error","type":"object"}}}}
```

## GET /api/v4.3/accounts/{entry\_id}/api-keys

> Get API keys for a user

```json
{"openapi":"3.0.2","info":{"title":"Link11 WAAP","version":"v4.3"},"paths":{"/api/v4.3/accounts/{entry_id}/api-keys":{"get":{"operationId":"get_self_api_key_api_v3_reblaze_tools_accounts__account_id__api_keys__get_2010584174585248031","summary":"Get API keys for a user","parameters":[{"in":"path","name":"entry_id","description":"Account ID","required":true,"schema":{"title":"Account ID","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"title":"APIKeysGetResponse","properties":{"total":{"type":"integer"},"items":{"type":"array","items":{"$ref":"#/components/schemas/ApiKey"}}}}}},"description":"API keys for specified user were retrieved successfully"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InputError"}}},"description":"Input Error"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"500":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Internal Server Error"}},"tags":["Users"]}}},"components":{"schemas":{"ApiKey":{"properties":{"account_id":{"title":"Account Id","type":"string"},"created_by":{"title":"Created By","type":"string"},"created_time":{"title":"Created Time","type":"number"},"email":{"title":"Email","type":"string"},"id":{"title":"Id","type":"string"},"key":{"title":"Key","type":"string"},"title":{"minLength":1,"title":"Title","type":"string"}},"required":["title","email","account_id","key","id","created_by","created_time"],"title":"ApiKey","type":"object"},"InputError":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"InputError","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"Error":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"Error","type":"object"}}}}
```

## POST /api/v4.3/accounts/{entry\_id}/api-keys

> Generate an API key for a user

```json
{"openapi":"3.0.2","info":{"title":"Link11 WAAP","version":"v4.3"},"paths":{"/api/v4.3/accounts/{entry_id}/api-keys":{"post":{"operationId":"generate_api_key_api_v3_reblaze_tools_account__account_id__api_keys__post_916302377811499112","summary":"Generate an API key for a user","parameters":[{"in":"path","name":"entry_id","description":"Account ID","required":true,"schema":{"title":"Account ID","type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/GenerateApiKeyBody"}}},"required":true},"responses":{"200":{"content":{"application/json":{"schema":{}}},"description":"API key for specified user was generated successfully"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InputError"}}},"description":"Input Error"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"500":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Internal Server Error"}},"tags":["Users"]}}},"components":{"schemas":{"GenerateApiKeyBody":{"properties":{"title":{"minLength":1,"title":"Title","type":"string"}},"required":["title"],"title":"GenerateApiKeyBody","type":"object"},"InputError":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"InputError","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"Error":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"Error","type":"object"}}}}
```

## GET /api/v4.3/accounts/sso

> Get SSO Config for the planet

```json
{"openapi":"3.0.2","info":{"title":"Link11 WAAP","version":"v4.3"},"paths":{"/api/v4.3/accounts/sso":{"get":{"operationId":"get_api_v3_reblaze_tools_sso__get_2115259266319238329","summary":"Get SSO Config for the planet","parameters":[],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SSOConfigResponse"}}},"description":"SSO config retrieved successfully"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InputError"}}},"description":"Bad Request"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"500":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Internal Server Error"}},"tags":["Users"]}}},"components":{"schemas":{"SSOConfigResponse":{"properties":{"enabled":{"default":false,"description":"Is that profile enabled or not.","title":"Enabled","type":"boolean"},"params":{"anyOf":[{"$ref":"#/components/schemas/SSOOAuthConfigParams"},{"$ref":"#/components/schemas/SSOSAML2ConfigParamsResponse"}],"description":"SSO provider parameters","title":"Params"},"protocol":{"allOf":[{"$ref":"#/components/schemas/ProtocolEnum"}],"description":"SSO protocol"},"provider":{"allOf":[{"$ref":"#/components/schemas/ProviderEnum"}],"description":"SSO provider"},"title":{"description":"Title of the SSO profile that will be displayed on the login page.","title":"Title","type":"string"}},"required":["title","provider","protocol","params"],"title":"SSOConfigResponse","type":"object"},"SSOOAuthConfigParams":{"properties":{"client_id":{"description":"SSO provider parameter","title":"Client Id","type":"string"},"client_secret":{"description":"SSO provider parameter","title":"Client Secret","type":"string"},"issuer":{"description":"SSO provider parameter","title":"Issuer","type":"string"},"roles":{"default":[],"description":"A mapping between IDP group ID and Reblaze groups","items":{"$ref":"#/components/schemas/SSOConfigRole"},"title":"Roles","type":"array"},"roles_claim_key":{"description":"Name of the JWT token field that is considered as list of user groups. E.g.: claims, groups, etc","title":"Roles Claim Key","type":"string"},"token_expiration_threshold":{"description":"Seconds until expiration date when token will be automatically refreshed.","title":"Token Expiration Threshold","type":"integer"}},"required":["client_id","client_secret","issuer"],"title":"SSOOAuthConfigParams","type":"object"},"SSOConfigRole":{"properties":{"idp_group":{"description":"IDP group ID","minLength":1,"title":"Idp Group","type":"string"},"waap_groups":{"description":"Reblaze groups","items":{"$ref":"#/components/schemas/SSOGroupsEnum"},"type":"array"}},"required":["idp_group","waap_groups"],"title":"SSOConfigRole","type":"object"},"SSOGroupsEnum":{"description":"An enumeration.","enum":["waap-events-viewer","waap-config-viewer","waap-config-editor","waap-manager"],"title":"SSOGroupsEnum","type":"string"},"SSOSAML2ConfigParamsResponse":{"properties":{"cert_thumbprint":{"description":"Certificate thumbprint to show user certificate if correct. Is used only for user output.","title":"Cert Thumbprint","type":"string"},"entityId":{"description":"entity ID","title":"Entityid","type":"string"},"login_url":{"description":"SAML2 account login url","format":"uri","maxLength":65536,"minLength":1,"title":"Login Url","type":"string"},"roles":{"default":[],"description":"A mapping between IDP group ID and Reblaze groups","items":{"$ref":"#/components/schemas/SSOConfigRole"},"title":"Roles","type":"array"},"roles_claim_key":{"description":"Name of the JWT token field that is considered as list of user groups. E.g.: claims, groups, etc","title":"Roles Claim Key","type":"string"},"tenantId":{"description":"tenant ID","title":"Tenantid","type":"string"},"token_expiration_threshold":{"description":"Seconds until expiration date when token will be automatically refreshed.","title":"Token Expiration Threshold","type":"integer"},"x509cert":{"description":"SAML2 signing certificate","title":"X509Cert","type":"string"}},"required":["tenantId","entityId","login_url"],"title":"SSOSAML2ConfigParamsResponse","type":"object"},"ProtocolEnum":{"type":"string","title":"ProtocolEnum","enum":["tcp","udp"]},"ProviderEnum":{"description":"An enumeration.","enum":["okta","azure","google"],"title":"ProviderEnum","type":"string"},"InputError":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"InputError","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"Error":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"Error","type":"object"}}}}
```

## POST /api/v4.3/accounts/sso/oauth2

> Add/Update SSO Config of OAuth2 protocol for the planet

```json
{"openapi":"3.0.2","info":{"title":"Link11 WAAP","version":"v4.3"},"paths":{"/api/v4.3/accounts/sso/oauth2":{"post":{"operationId":"update_oauth2_api_v3_reblaze_tools_sso_oauth2__post_1212754803400318576","summary":"Add/Update SSO Config of OAuth2 protocol for the planet","parameters":[],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SSOOAuthConfig"}}},"required":true},"responses":{"201":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SSOSimpleResponse"}}},"description":"SSO config was updated successfully"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InputError"}}},"description":"Bad Request"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"500":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Internal Server Error"}},"tags":["Users"]}}},"components":{"schemas":{"SSOOAuthConfig":{"properties":{"enabled":{"default":false,"description":"Is that profile enabled or not.","title":"Enabled","type":"boolean"},"params":{"allOf":[{"$ref":"#/components/schemas/SSOOAuthConfigParams"}],"description":"SSO provider OAuth2 protocol parameters","title":"Params"},"protocol":{"allOf":[{"$ref":"#/components/schemas/ProtocolEnum"}],"description":"SSO protocol"},"provider":{"allOf":[{"$ref":"#/components/schemas/ProviderEnum"}],"description":"SSO provider"},"title":{"description":"Title of the SSO profile that will be displayed on the login page.","title":"Title","type":"string"}},"required":["title","provider","protocol","params"],"title":"SSOOAuthConfig","type":"object"},"SSOOAuthConfigParams":{"properties":{"client_id":{"description":"SSO provider parameter","title":"Client Id","type":"string"},"client_secret":{"description":"SSO provider parameter","title":"Client Secret","type":"string"},"issuer":{"description":"SSO provider parameter","title":"Issuer","type":"string"},"roles":{"default":[],"description":"A mapping between IDP group ID and Reblaze groups","items":{"$ref":"#/components/schemas/SSOConfigRole"},"title":"Roles","type":"array"},"roles_claim_key":{"description":"Name of the JWT token field that is considered as list of user groups. E.g.: claims, groups, etc","title":"Roles Claim Key","type":"string"},"token_expiration_threshold":{"description":"Seconds until expiration date when token will be automatically refreshed.","title":"Token Expiration Threshold","type":"integer"}},"required":["client_id","client_secret","issuer"],"title":"SSOOAuthConfigParams","type":"object"},"SSOConfigRole":{"properties":{"idp_group":{"description":"IDP group ID","minLength":1,"title":"Idp Group","type":"string"},"waap_groups":{"description":"Reblaze groups","items":{"$ref":"#/components/schemas/SSOGroupsEnum"},"type":"array"}},"required":["idp_group","waap_groups"],"title":"SSOConfigRole","type":"object"},"SSOGroupsEnum":{"description":"An enumeration.","enum":["waap-events-viewer","waap-config-viewer","waap-config-editor","waap-manager"],"title":"SSOGroupsEnum","type":"string"},"ProtocolEnum":{"type":"string","title":"ProtocolEnum","enum":["tcp","udp"]},"ProviderEnum":{"description":"An enumeration.","enum":["okta","azure","google"],"title":"ProviderEnum","type":"string"},"SSOSimpleResponse":{"properties":{"cert_thumbprint":{"description":"Certificate thumbprint to show user certificate if correct. Is used only for user output.","title":"Cert Thumbprint","type":"string"},"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"SSOSimpleResponse","type":"object"},"InputError":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"InputError","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"Error":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"Error","type":"object"}}}}
```

## POST /api/v4.3/accounts/sso/saml2

> Add/Update SSO Config of SAML2 protocol for the planet

```json
{"openapi":"3.0.2","info":{"title":"Link11 WAAP","version":"v4.3"},"paths":{"/api/v4.3/accounts/sso/saml2":{"post":{"operationId":"update_saml2_api_v3_reblaze_tools_sso_saml2__post_915369997435549761","summary":"Add/Update SSO Config of SAML2 protocol for the planet","parameters":[],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SSOSAML2Config"}}},"required":true},"responses":{"201":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SSOSimpleResponse"}}},"description":"SSO config was updated successfully"},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InputError"}}},"description":"Bad Request"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"500":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}},"description":"Internal Server Error"}},"tags":["Users"]}}},"components":{"schemas":{"SSOSAML2Config":{"properties":{"enabled":{"default":false,"description":"Is that profile enabled or not.","title":"Enabled","type":"boolean"},"params":{"allOf":[{"$ref":"#/components/schemas/SSOSAML2ConfigParams"}],"description":"SSO provider SAML2 protocol parameters","title":"Params"},"protocol":{"allOf":[{"$ref":"#/components/schemas/ProtocolEnum"}],"description":"SSO protocol"},"provider":{"allOf":[{"$ref":"#/components/schemas/ProviderEnum"}],"description":"SSO provider"},"title":{"description":"Title of the SSO profile that will be displayed on the login page.","title":"Title","type":"string"}},"required":["title","provider","protocol","params"],"title":"SSOSAML2Config","type":"object"},"SSOSAML2ConfigParams":{"properties":{"entityId":{"description":"entity ID","title":"Entityid","type":"string"},"login_url":{"description":"SAML2 account login url","format":"uri","maxLength":65536,"minLength":1,"title":"Login Url","type":"string"},"roles":{"default":[],"description":"A mapping between IDP group ID and Reblaze groups","items":{"$ref":"#/components/schemas/SSOConfigRole"},"title":"Roles","type":"array"},"roles_claim_key":{"description":"Name of the JWT token field that is considered as list of user groups. E.g.: claims, groups, etc","title":"Roles Claim Key","type":"string"},"tenantId":{"description":"tenant ID","title":"Tenantid","type":"string"},"token_expiration_threshold":{"description":"Seconds until expiration date when token will be automatically refreshed.","title":"Token Expiration Threshold","type":"integer"},"x509cert":{"description":"SAML2 signing certificate","title":"X509Cert","type":"string"}},"required":["tenantId","entityId","login_url"],"title":"SSOSAML2ConfigParams","type":"object"},"SSOConfigRole":{"properties":{"idp_group":{"description":"IDP group ID","minLength":1,"title":"Idp Group","type":"string"},"waap_groups":{"description":"Reblaze groups","items":{"$ref":"#/components/schemas/SSOGroupsEnum"},"type":"array"}},"required":["idp_group","waap_groups"],"title":"SSOConfigRole","type":"object"},"SSOGroupsEnum":{"description":"An enumeration.","enum":["waap-events-viewer","waap-config-viewer","waap-config-editor","waap-manager"],"title":"SSOGroupsEnum","type":"string"},"ProtocolEnum":{"type":"string","title":"ProtocolEnum","enum":["tcp","udp"]},"ProviderEnum":{"description":"An enumeration.","enum":["okta","azure","google"],"title":"ProviderEnum","type":"string"},"SSOSimpleResponse":{"properties":{"cert_thumbprint":{"description":"Certificate thumbprint to show user certificate if correct. Is used only for user output.","title":"Cert Thumbprint","type":"string"},"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"SSOSimpleResponse","type":"object"},"InputError":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"InputError","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"},"Error":{"properties":{"code":{"title":"Code","type":"integer"},"message":{"title":"Message","type":"string"}},"required":["code","message"],"title":"Error","type":"object"}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://waap.docs.link11.com/reference-information/api/namespace-reference/users.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
